---
title: ':-moz-focusring'
slug: 'Web/CSS/:-moz-focusring'
tags:
  - CSS
  - 'CSS:Mozilla Extensions'
  - Non-standard
  - Pseudo-class
  - Reference
  - Selector
---
<div>{{Non-standard_header}}{{CSSRef}}</div>

<p>The <strong><code>:-moz-focusring</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> is a <a href="/en-US/docs/Web/CSS/Mozilla_Extensions">Mozilla extension</a> that is similar to the {{cssxref(":focus")}} pseudo-class, but it only matches an element if it's currently focused <em>and</em> a focus ring or other indicator should be drawn around it.</p>

<div class="notecard note">
<p><strong>Important</strong>: This selector has been renamed to {{cssxref(":focus-visible")}} for the CSS Selectors 4 specification.</p>
</div>

<p>If <code>:-moz-focusring</code> matches, then <code>:focus</code> also matches, but the converse is not always true: it depends on whether the <a href="/en-US/docs/Glossary/User_agent">user agent</a> has focus ring drawing enabled and how the element was focused. Whether the user agent has focus ring drawing enabled can depend on operating system settings and other factors, so the precise behavior of this pseudo-class will vary from platform to platform.</p>

<p>The working group previously <a href="https://lists.w3.org/Archives/Public/www-style/2015Oct/0012.html">intended to add this feature to CSS Selectors 4 or 5</a> as <code>:focus-ring</code>, and has since <a href="https://lists.w3.org/Archives/Public/www-style/2017Dec/0018.html">decided to rename it</a> to {{cssxref(":focus-visible")}} and added it to CSS Selectors 4.</p>

<div class="note">
<p><strong>Note</strong>: Developers tend to use <code>:-moz-focusring</code> to differentiate between the <code>focus</code> state when the user focuses an element via a <strong>mouse </strong><strong>click</strong> versus <strong>keyboard tabbing</strong>. It is also potentially useful if you are creating a <a href="/en-US/docs/Web/Web_Components/Using_custom_elements">custom element</a> and you want to change its style based on its behavior.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">:-moz-focusring</pre>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;input /&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">input {
  margin: 5px;
}

:-moz-focusring {
  color: red;
  outline: 2px dotted green;
}
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example')}}</p>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.-moz-focusring")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref(":focus-visible")}}</li>
 <li>{{bug("418521")}}</li>
</ul>
